library shdow_text;

import 'package:flutter/material.dart';

typedef ShadowBuilder = Widget Function(
    BuildContext context, String text, Color color);

class ShadowText extends StatelessWidget {
  final String text;
  final Color color;
  final Color shadowColor;
  final int offestX;
  final int offestY;
  final ShadowBuilder shadowBuilder;

  ShadowText(
      {Key key,
      @required this.text,
      @required this.color,
      @required this.shadowColor,
      this.offestX,
      this.offestY,
      @required this.shadowBuilder})
      : assert(text != null),
        assert(color != null),
        assert(shadowColor != null),
        assert(shadowBuilder != null),
        super(key: key);

  @override
  Widget build(BuildContext context) {
    return Stack(
      children: <Widget>[
        Transform(
          transform: Matrix4.translationValues(offestX ?? 10, offestY ?? 10, 0),
          child: shadowBuilder(context, text, shadowColor),
        ),
        shadowBuilder(context, text, color)
      ],
    );
  }
}
